/////////////////////////
// TEXTURE DECLARATION //
/////////////////////////

#declare TestTex3=
  texture {
    pigment {
      bozo
      turbulence 0.243
      color_map {
        [0.00 rgb<0.26, 0.28, 0.28>]
          [0.17 rgb<0.235, 0.255, 0.205>]
        [0.32 rgb<0.21, 0.23, 0.18>]
          [0.53 rgb<0.295, 0.3175, 0.2175>]
        [0.74 rgb<0.38, 0.405, 0.255>]
          [0.87 rgb<0.32, 0.3425, 0.2675>]
        [1.00 rgb<0.26, 0.28, 0.28>]
      }
      scale 2
    }
    normal {granite 4 scale 5 turbulence 0.43}
    finish {specular 0.13 roughness 0.3 brilliance 3.74 ambient 0.05}
  }


/////////////////////////
// OBJECT DECLARATIONS //
/////////////////////////

#declare R1=seed(9803)

#declare FUnit1=
  superellipsoid {<0.2975, 0.4725>}

#declare FUnit2=
  union {
    object {FUnit1 scale <0.5, 1, 0.5>}
    object {FUnit1 scale <1.5, 1, 0.5> translate <1, 0, 1>}
    object {FUnit1 scale <0.5, 1, 1.5> translate <1, 0, -1>}
    object {FUnit1 scale <1.5, 1, 0.5> translate <-1, 0, -1>}
    object {FUnit1 scale <0.5, 1, 1.5> translate <-1, 0, 1>}
    scale <2, 1, 2>
  }


#declare Counter1=0

#declare FLL=
union {
  #while (Counter1 < 17)
    object {FUnit2 translate <-78+(16*Counter1), 0, 78-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-72+(16*Counter1), 0, 74-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-66+(16*Counter1), 0, 70-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-60+(16*Counter1), 0, 66-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-54+(16*Counter1), 0, 62-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-48+(16*Counter1), 0, 58-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-42+(16*Counter1), 0, 54-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    object {FUnit2 translate <-36+(16*Counter1), 0, 50-(2*Counter1)>
      texture {TestTex3 rotate <360*rand(R1), 360*rand(R1), 360*rand(R1)>}
    }
    #declare Counter1=Counter1+1
  #end
}

#declare FLL2=
  union {
    object {FLL translate <-35, -10, 22>}
    object {FLL translate <-35, -10, -4>}
    object {FLL translate <-35, -10, -30>}
    object {FLL translate <-35, -10, -56>}
    object {FLL translate <-35, -10, -82>}
    object {FLL translate <-35, -10, -108>}
  }

